   This file documents GNU Info, a program for viewing the on-line
formatted versions of Texinfo files.  This documentation is different
from the documentation for the Info reader that is part of GNU Emacs.
If you do not know how to use Info, but have a working Info reader, you
should read that documentation first.

   Copyright (C) 1992, 93, 96, 97, 98, 99 Free Software Foundation, Inc.

   Permission is granted to make and distribute verbatim copies of this
manual provided the copyright notice and this permission notice are
preserved on all copies.

   Permission is granted to copy and distribute modified versions of
this manual under the conditions for verbatim copying, provided also
that the sections entitled "Copying" and "GNU General Public License"
are included exactly as in the original, and provided that the entire
resulting derived work is distributed under the terms of a permission
notice identical to this one.

   Permission is granted to copy and distribute translations of this
manual into another language, under the above conditions for modified
versions, except that this permission notice may be stated in a
translation approved by the Free Software Foundation.

GNU Info
********

   This file documents GNU Info, a program for viewing the on-line
formatted versions of Texinfo files, version 4.0.  This documentation
is different from the documentation for the Info reader that is part of
GNU Emacs.

   This manual is for Info version 4.0, updated 28 September 1999.

What is Info?
*************

   "Info" is a program which is used to view Info files on an ASCII
terminal.  "Info files" are the result of processing Texinfo files with
the program `makeinfo' or with one of the Emacs commands, such as `M-x
texinfo-format-buffer'.  Texinfo itself is a documentation system that
uses a single source file to produce both on-line information and
printed output.  You can typeset and print the files that you read in
Info.

Invoking Info
*************

   GNU Info accepts several options to control the initial node being
viewed, and to specify which directories to search for Info files.  Here
is a template showing an invocation of GNU Info from the shell:

     info [OPTION]... [MENU-ITEM...]

   The program accepts the following options:

`--apropos=STRING'
     Specify a string to search in every index of every Info file
     installed on your system.  Info looks up the named STRING in all
     the indices it can find, prints the results to standard output,
     and then exits.  If you are not sure which Info file explains
     certain issues, this option is your friend.  Note that if your
     system has a lot of Info files installed, searching all of them
     might take some time.

`--directory DIRECTORY-PATH'
`-d DIRECTORY-PATH'
     Prepend DIRECTORY-PATH to the list of directory paths searched
     when Info needs to find a file.  You may issue `--directory'
     multiple times; once for each directory which contains Info files.
     The list of directories searched by Info is constructed from the
     value of the environment variable `INFOPATH'; `--directory' causes
     the named DIRECTORY-PATH to be prepended to that list.  The value
     of `INFOPATH' is a list of directories usually separated by a
     colon; on MS-DOS/MS-Windows systems, the semicolon is used.  If
     you do not define `INFOPATH', Info uses a default path defined
     when Info was built as the initial list of directories.  If the
     value of `INFOPATH' ends with a colon (or semicolon on
     MS-DOS/MS-Windows), the initial list of directories is constructed
     by appending the build-time default to the value of `INFOPATH'.

`--dribble=DRIBBLE-FILE'
     Specify a file where all user keystrokes will be recorded.  This
     file can be used later to replay the same sequence of commands,
     see the `--restore' option below.

`--file FILENAME'
`-f FILENAME'
     Specify a particular Info file to visit.  By default, Info visits
     the file `dir'; if you use this option, Info will start with
     `(FILENAME)Top' as the first file and node.

     If FILENAME is an absolute file name, or begins with `./' or
     `../', Info looks for FILENAME only in the directory of the
     specified FILENAME, and adds the directory of FILENAME to the
     value of `INFOPATH'.  In contrast, if FILENAME is in the form of a
     relative file name, but without the `./' or `../' prefix, Info
     will only look for it in the directories specified in `INFOPATH'.
     In other words, Info does _not_ treat file names which lack `./'
     and `../' prefix as relative to the current directory.

     In every directory Info tries, if FILENAME is not found, Info
     looks for it with a number of known extensions of Info files(1).
     For every known extension, Info looks for a compressed file, if a
     regular file isn't found.  Info supports files compressed with
     `gzip', `bzip2', `compress' and `yabba' programs; it calls
     `gunzip', `bunzip2', `uncompress' and `unyabba', accordingly, to
     decompress such files.  Compressed Info files are assumed to have
     `.z', `.gz', `.bz2', `.Z', or `.Y' extensions, possibly in
     addition to one of the known Info files extensions(2).

`--help'
`-h'
     Produces a relatively brief description of the available Info
     options.

`--index-search STRING'
     After processing all command-line arguments, go to the index in
     the Info file and search for index entries which matche STRING.
     If such an entry is found, the Info session begins with displaying
     the node pointed to by the first matching index entry; press `,'
     to step through the rest of the matching entries.  If no such
     entry exists, print `no entries found' and exit with nonzero
     status.  This can be used from another program as a way to provide
     online help, or as a quick way of starting to read an Info file at
     a certain node when you don't know the exact name of that node.

`--node NODENAME'
`-n NODENAME'
     Specify a particular node to visit in the initial file that Info
     loads.  This is especially useful in conjunction with `--file'(3).
     You may specify `--node' multiple times; for an interactive Info,
     each NODENAME is visited in its own window, for a non-interactive
     Info (such as when `--output' is given) each NODENAME is processed
     sequentially.

`--output FILENAME'
`-o FILENAME'
     Specify FILENAME as the name of a file to which to direct output.
     Each node that Info visits will be output to FILENAME instead of
     interactively viewed.  A value of `-' for FILENAME specifies the
     standard output.

`--restore=DRIBBLE-FILE'
     Read keystrokes from DRIBBLE-FILE, presumably recorded during
     previous Info session (see the description of the `--dribble'
     option above).  When the keystrokes in the files are all read, Info
     reverts its input to the usual interactive operation.

`--show-options'
`--usage'
`-O'
     This option causes Info to look for the node that describes how to
     invoke the program and its command-line options, and begin the
     session by displaying that node.  It is provided to make it easier
     to find the most important usage information in a manual without
     the need to wade through complex menu hierarchies.  The effect is
     similar to the `M-x goto-invocation' command (see
     goto-invocation) from inside Info.

`--speech-friendly'
`-b'
     On MS-DOS/MS-Windows only, this option causes Info to use standard
     file I/O functions for screen writes.  (By default, Info uses
     direct writes to the video memory on these systems, for faster
     operation and colored display support.)  This allows the speech
     synthesizers used by blind persons to catch the output and convert
     it to audible speech.

`--subnodes'
     This option only has meaning when given in conjunction with
     `--output'.  It means to recursively output the nodes appearing in
     the menus of each node being output.  Menu items which resolve to
     external Info files are not output, and neither are menu items
     which are members of an index.  Each node is only output once.

`--version'
     Prints the version information of Info and exits.

`--vi-keys'
     This option binds functions to keys differently, to emulate the key
     bindings of `vi' and Less.  The default key bindings are generally
     modeled after Emacs.

`MENU-ITEM'
     Info treats its remaining arguments as the names of menu items.
     The first argument is a menu item in the initial node visited
     (generally `dir'), the second argument is a menu item in the first
     argument's node, etc.  You can easily move to the node of your
     choice by specifying the menu names which describe the path to
     that node.  For example,

          info emacs buffers

     first selects the menu item `Emacs' in the node `(dir)Top', and
     then selects the menu item `Buffers' in the node `(emacs)Top'.

   To avoid searching the `dir' files and just show some arbitrary
file, use `-f' and the filename, as in `info -f ./foo.info'.

   The index search and the search for the node which describes program
invocation and command-line options begins _after_ processing all the
command-line menu items.  Therefore, the Info file searched for the
index or the invocation node is the file where Info finds itself after
following all the menu items given on the command line.  This is so
`info emacs --show-options' does what you'd expect.

   ---------- Footnotes ----------

   (1) `.info', `-info', `/index', and `.inf'.

   (2) The MS-DOS version allows for the Info extension, such as
`.inf', and the short compressed file extensions, such as `.z' and
`.gz', to be merged into a single extension, since DOS doesn't allow
more than a single dot in the basename of a file.  Thus, on MS-DOS, if
Info looks for `bison', file names like `bison.igz' and `bison.inz'
will be found and decompressed by `gunzip'.

   (3) Of course, you can specify both the file and node in a `--node'
command; but don't forget to escape the open and close parentheses and
whitespace from the shell as in: `info --node "(emacs)Buffers"'.

Moving the Cursor
*****************

   Many people find that reading screens of text page by page is made
easier when one is able to indicate particular pieces of text with some
kind of pointing device.  Since this is the case, GNU Info (both the
Emacs and standalone versions) have several commands which allow you to
move the cursor about the screen.  The notation used in this manual to
describe keystrokes is identical to the notation used within the Emacs
manual, and the GNU Readline manual.  See Character Conventions (emacs),
if you are unfamiliar with the notation(1).

   The following table lists the basic cursor movement commands in Info.
Each entry consists of the key sequence you should type to execute the
cursor movement, the `M-x'(2) command name (displayed in parentheses),
and a short description of what the command does.  All of the cursor
motion commands can take a "numeric" argument (see
`universal-argument'.  With a numeric argument,
the motion commands are simply executed that many times; for example, a
numeric argument of 4 given to `next-line' causes the cursor to move
down 4 lines.  With a negative numeric argument, the motion is
reversed; an argument of -4 given to the `next-line' command would
cause the cursor to move _up_ 4 lines.

<C-n> (`next-line')
<DOWN> (an arrow key)
     Move the cursor down to the next line.

<C-p> (`prev-line')
<UP> (an arrow key)
     Move the cursor up to the previous line.

<C-a> (`beginning-of-line')
<Home> (on DOS/Windows only)
     Move the cursor to the start of the current line.

<C-e> (`end-of-line')
<End> (on DOS/Windows only)
     Move the cursor to the end of the current line.

<C-f> (`forward-char')
<RIGHT> (an arrow key)
     Move the cursor forward a character.

<C-b> (`backward-char')
<LEFT> (an arrow key)
     Move the cursor backward a character.

<M-f> (`forward-word')
`C-<RIGHT>' (on DOS/Windows only)
     Move the cursor forward a word.

<M-b> (`backward-word')
`C-<LEFT>' (on DOS/Windows only)
     Move the cursor backward a word.

<M-<> (`beginning-of-node')
<C-<Home>> (on DOS/Windows only)
<b>
<M-b>, vi-like operation
     Move the cursor to the start of the current node.

<M->> (`end-of-node')
<C-<End>> (on DOS/Windows only)
<e>
     Move the cursor to the end of the current node.

<M-r> (`move-to-window-line')
     Move the cursor to a specific line of the window.  Without a
     numeric argument, `M-r' moves the cursor to the start of the line
     in the center of the window.  With a numeric argument of N, `M-r'
     moves the cursor to the start of the Nth line in the window.

   ---------- Footnotes ----------

   (1) Here's a short summary.  `C-X' means press the `CTRL' key and
the key X.  `M-X' means press the `META' key and the key X.  On many
terminals th `META' key is known as the `ALT' key.  `SPC' is the space
bar.  The other keys are usually called by the names imprinted on them.

   (2) `M-x' is also a command; it invokes `execute-extended-command'.
See Executing an extended command (emacs), for more detailed
information.

Moving Text Within a Window
***************************

   Sometimes you are looking at a screenful of text, and only part of
the current paragraph you are reading is visible on the screen.  The
commands detailed in this section are used to shift which part of the
current node is visible on the screen.

   Scrolling commands are bound differently when `--vi-keys' operation
(see --vi-keys) is in effect.  These key bindings are designated
with "vi-like operation".

<SPC> (`scroll-forward')
<NEXT> (an arrow key)
<C-v>
<C-f>, vi-like operation
<f>, vi-like operation
<M-SPC>, vi-like operation
     Shift the text in this window up.  That is, show more of the node
     which is currently below the bottom of the window.  With a numeric
     argument, show that many more lines at the bottom of the window; a
     numeric argument of 4 would shift all of the text in the window up
     4 lines (discarding the top 4 lines), and show you four new lines
     at the bottom of the window.  Without a numeric argument, <SPC>
     takes the bottom two lines of the window and places them at the
     top of the window, redisplaying almost a completely new screenful
     of lines.  If you are at the end of a node, SPC takes you to the
     "next" node, so that you can read an entire manual from start to
     finish by repeating SPC.

     The default scroll size is one screen-full, but it can be changed
     by invoking the (`scroll-forward-set-window') command, `z' under
     `--vi-keys', with a numeric argument.

     The <NEXT> key is known as the <PageDown> key on some keyboards.
     When you use <NEXT> or <PageDown> to scroll, Info never scrolls
     beyond the end of the current node.

<z> (`scroll-forward-set-window', vi-like operation)
     Scroll forward, like with <SPC>, but if a numeric argument is
     specified, it becomes the default scroll size for subsequent
     `scroll-forward' and `scroll-backward' commands.

<DEL> (`scroll-backward')
<PREVIOUS> (arrow key)
<PRIOR> (arrow key)
<M-v>
<b>, vi-like operation
<C-b>, vi-like operation
     Shift the text in this window down.  The inverse of
     `scroll-forward'.  The default scroll size can be changed by
     invoking the(`scroll-backward-set-window') command, `w' under
     `--vi-keys', with a numeric argument.

<w> (`scroll-backward-set-window', vi-like operation)
     Scroll backward, like with <DEL>, but if a numeric argument is
     specified, it becomes the default scroll size for subsequent
     `scroll-forward' and `scroll-backward' commands.

<C-n> (`down-line', vi-like operation)
<C-e>, vi-like operation
<RET>, vi-like operation
<LFD>, vi-like operation
<DOWN>, vi-like operation
     Scroll forward by one line.  With a numeric argument, scroll
     forward that many lines.

<C-p> (`up-line', vi-like operation)
<UP>, vi-like operation
<y>, vi-like operation
<k>, vi-like operation
<C-k>, vi-like operation
<C-y>, vi-like operation
     Scroll backward one line.  With a numeric argument, scroll
     backward that many lines.

<d> (`scroll-half-screen-down', vi-like operation)
<C-d>, vi-like operation
     Scroll forward by half of the screen size.  With a numeric
     argument, scroll that many lines.  If an argument is specified, it
     becomes the new default number of lines to scroll for subsequent
     `d' and `u' commands.

<u> (`scroll-half-screen-up', vi-like operation)
<C-u>, vi-like operation
     Scroll back by half of the screen size.  With a numeric argument,
     scroll that many lines.  If an argument is specified, it becomes
     the new default number of lines to scroll for subsequent `u' and
     `d' commands.

   The `scroll-forward' and `scroll-backward' commands can also move
forward and backward through the node structure of the file.  If you
press <SPC> while viewing the end of a node, or <DEL> while viewing the
beginning of a node, what happens is controlled by the variable
`scroll-behavior'.  See `scroll-behavior', for more
information.

   The <PREVIOUS> key is the <PageUp> key on many keyboards.  Emacs
refers to it by the name <PRIOR>.  When you use <PRIOR> or <PageUp> to
scroll, Info never scrolls beyond the beginning of the current node.

   If your keyboard lacks the <DEL> key, look for a key called <BS>, or
`BackSpace', sometimes designated with an arrow which points to the
left, which should perform the same function.

<C-l> (`redraw-display')
     Redraw the display from scratch, or shift the line containing the
     cursor to a specified location.  With no numeric argument, `C-l'
     clears the screen, and then redraws its entire contents.  Given a
     numeric argument of N, the line containing the cursor is shifted
     so that it is on the Nth line of the window.

`C-x <w>' (`toggle-wrap')
     Toggles the state of line wrapping in the current window.
     Normally, lines which are longer than the screen width "wrap",
     i.e., they are continued on the next line.  Lines which wrap have
     a `\' appearing in the rightmost column of the screen.  You can
     cause such lines to be terminated at the rightmost column by
     changing the state of line wrapping in the window with `C-x w'.
     When a line which needs more space than one screen width to
     display is displayed, a `$' appears in the rightmost column of the
     screen, and the remainder of the line is invisible.  When long
     lines are truncated, the modeline displays the `$' character near
     its left edge.

Selecting a New Node
********************

   This section details the numerous Info commands which select a new
node to view in the current window.

   The most basic node commands are `n', `p', `u', and `l'.  Note that
the commands to select nodes are mapped differently when `--vi-keys' is
in effect; these keybindings are designated below as "vi-like
operation".

   When you are viewing a node, the top line of the node contains some
Info "pointers" which describe where the next, previous, and up nodes
are.  Info uses this line to move about the node structure of the file
when you use the following commands:

<n> (`next-node')
`C-<NEXT>' (on DOS/Windows only)
`C-x <n>', vi-like operation
     Select the `Next' node.

     The <NEXT> key is known as the <PgDn> key on some keyboards.

<p> (`prev-node')
`C-<PREVIOUS>' (on DOS/Windows only)
     Select the `Prev' node.

     The <PREVIOUS> key is known as the <PgUp> key on some keyboards.

<u> (`up-node')
`C-<UP>' (an arrow key on DOS/Windows only)
`C-x <u>', vi-like operation
     Select the `Up' node.

   You can easily select a node that you have already viewed in this
window by using the `l' command - this name stands for "last", and
actually moves backwards through the history of visited nodes for this
window.  This is handy when you followed a reference to another node,
possibly to read about a related issue, and would like then to resume
reading at the same place where you started the excursion.

   Each node where you press `l' is discarded from the history.  Thus,
by the time you get to the first node you visited in a window, the
entire history of that window is discarded.

<l> (`history-node')
<C-<CENTER>> (on DOS/Windows only)
<'>, vi-like operation
     Pop the most recently selected node in this window from the node
     history.

   Two additional commands make it easy to select the most commonly
selected nodes; they are `t' and `d'.

<t> (`top-node')
<M-t>, vi-like operation
     Select the node `Top' in the current Info file.

<d> (`dir-node')
<M-d>, vi-like operation
     Select the directory node (i.e., the node `(dir)').

   Here are some other commands which immediately result in the
selection of a different node in the current window:

<<> (`first-node')
<g>, vi-like operation
     Selects the first node which appears in this file.  This node is
     most often `Top', but it does not have to be.  With a numeric
     argument N, select the Nth node (the first node is node 1).  An
     argument of zero is the same as the argument of 1.

<>> (`last-node')
<G>, vi-like operation
     Select the last node which appears in this file.  With a numeric
     argument N, select the Nth node (the first node is node 1).  An
     argument of zero is the same as no argument, i.e., it selects the
     last node.

<]> (`global-next-node')
     Move forward or down through node structure.  If the node that you
     are currently viewing has a `Next' pointer, that node is selected.
     Otherwise, if this node has a menu, the first menu item is
     selected.  If there is no `Next' and no menu, the same process is
     tried with the `Up' node of this node.

<[> (`global-prev-node')
     Move backward or up through node structure.  If the node that you
     are currently viewing has a `Prev' pointer, that node is selected.
     Otherwise, if the node has an `Up' pointer, that node is selected,
     and if it has a menu, the last item in the menu is selected.

   You can get the same behavior as `global-next-node' and
`global-prev-node' while simply scrolling through the file with <SPC>
and <DEL>; see `scroll-behavior', for more information.

<g> (`goto-node')
`C-x <g>', vi-like operation
     Read the name of a node and select it.  While reading the node
     name, completion (see completion) is only done
     for the nodes which reside in one of the Info files that were
     loaded in the current Info session; if the desired node resides in
     some other file, you must type the node exactly as it appears in
     that Info file, and you must include the Info file of the other
     file.  For example,

          `g(emacs)Buffers'

     finds the node `Buffers' in the Info file `emacs'.

<O> (`goto-invocation'
<I>
     Read the name of a program and look for a node in the current Info
     file which describes the invocation and the command-line options
     for that program.  The default program name is derived from the
     name of the current Info file.  This command does the same as the
     `--show-options' command-line option (see --show-options), but
     it also allows to specify the program name; this is important for
     those manuals which describe several programs.

     If you need to find the Invocation node of a program that is
     documented in another Info file, you need to visit that file
     before invoking `I'.  For example, if you are reading the Emacs
     manual and want to see the command-line options of the `makeinfo'
     program, type `g (texinfo) <RET>' and then `I makeinfo <RET>'.  If
     you don't know what Info file documents the command, or if
     invoking `I' doesn't display the right node, go to the `(dir)'
     node (using the `d' command) and invoke `I' from there.

<G> (`menu-sequence')
     Read a sequence of menu entries and follow it.  Info prompts for a
     sequence of menu items separated by commas.  (Since commas are not
     allowed in a node name, they are a natural choice for a delimiter
     in a list of menu items.)  Info then looks up the first item in
     the menu of the node `(dir)' (if the `(dir)' node cannot be found,
     Info uses `Top').  If such an entry is found, Info goes to the
     node it points to and looks up the second item in the menu of that
     node, etc.  In other words, you can specify a complete path which
     descends through the menu hierarchy of a particular Info file
     starting at the `(dir)' node.  This has the same effect as if you
     typed the menu item sequence on Info's command line, see
     Info command-line arguments processing.
     For example,

           G Texinfo,Overview,Reporting Bugs <RET>

     displays the node `Reporting Bugs' in the Texinfo manual.  (You
     don't actually need to type the menu items in their full length,
     or in their exact letter-case.  However, if you do type the menu
     items exactly, Info will find it faster.)

     If any of the menu items you type are not found, Info stops at the
     last entry it did find and reports an error.

`C-x <k>' (`kill-node')
     Kill a node.  The node name is prompted for in the echo area, with
     a default of the current node.  "Killing" a node means that Info
     tries hard to forget about it, removing it from the list of
     history nodes kept for the window where that node is found.
     Another node is selected in the window which contained the killed
     node.

`C-x C-f' (`view-file')
     Read the name of a file and selects the entire file.  The command
          `C-x C-f FILENAME'
     is equivalent to typing
          `g(FILENAME)*'

`C-x C-b' (`list-visited-nodes')
     Make a window containing a menu of all of the currently visited
     nodes.  This window becomes the selected window, and you may use
     the standard Info commands within it.

`C-x <b>' (`select-visited-node')
     Select a node which has been previously visited in a visible
     window.  This is similar to `C-x C-b' followed by `m', but no
     window is created.

Searching an Info File
**********************

   GNU Info allows you to search for a sequence of characters
throughout an entire Info file, search through the indices of an Info
file, or find areas within an Info file which discuss a particular
topic.

<s> (`search')
</>
     Read a string in the echo area and search for it.  If the string
     includes upper-case characters, the Info file is searched
     case-sensitively; otherwise Info ignores the letter case.  With a
     numeric argument of N, search for Nth occurrence of the string.
     Negative arguments search backwards.

<?> (`search-backward', vi-like operation)
     Read a string in the echo area and search backward through the
     Info file for that string.  If the string includes upper-case
     characters, the Info file is searched case-sensitively; otherwise
     Info ignores the letter case.  With a numeric argument of N,
     search for Nth occurrence of the string.  Negative arguments
     search forward.

<S> (`search-case-sensitively'
     Read a string in the echo area and search for it case-sensitively,
     even if the string includes only lower-case letters.  With a
     numeric argument of N, search for Nth occurrence of the string.
     Negative arguments search backwards.

`C-x <n>' (`search-next')
<n>, vi-like operation
     Search for the same string used in the last search command, in the
     same direction, and with the same case-sensitivity option.  With a
     numeric argument of N, search for Nth next occurrence.

`C-x <N>' (`search-previous')
<N>, vi-like operation
     Search for the same string used in the last search command, and
     with the same case-sensitivity option, but in the reverse
     direction.  With a numeric argument of N, search for Nth previous
     occurrence.

<C-s> (`isearch-forward')
     Interactively search forward through the Info file for a string as
     you type it.  If the string includes upper-case characters, the
     search is case-sensitive; otherwise Info ignores the letter case.

<C-r> (`isearch-backward')
     Interactively search backward through the Info file for a string as
     you type it.  If the string includes upper-case characters, the
     search is case-sensitive; otherwise Info ignores the letter case.

<i> (`index-search')
     Look up a string in the indices for this Info file, and select a
     node where the found index entry points to.

<,> (`next-index-match')
     Move to the node containing the next matching index item from the
     last `i' command.

   The most basic searching command is `s' or `/' (`search').  The `s'
command prompts you for a string in the echo area, and then searches
the remainder of the Info file for an occurrence of that string.  If
the string is found, the node containing it is selected, and the cursor
is left positioned at the start of the found string.  Subsequent `s'
commands show you the default search string within `[' and `]';
pressing <RET> instead of typing a new string will use the default
search string.  Under `--vi-keys' (see --vi-keys), using the `n' or
`N' commands is a faster way of searching for the same string.

   "Incremental searching" is similar to basic searching, but the
string is looked up while you are typing it, instead of waiting until
the entire search string has been specified.

   Both incremental and non-incremental search by default ignore the
case of letters when comparing the Info file text with the search
string.  However, an uppercase letter in the search string makes the
search case-sensitive.  You can force a case-sensitive non-incremental
search, even for a string that includes only lower-case letters, by
using the `S' command (`search-case-sensitively').  The `n' and `N'
commands operate case-sensitively if the last search command was `S'.

Selecting Cross References
**************************

   We have already discussed the `Next', `Prev', and `Up' pointers
which appear at the top of a node.  In addition to these pointers, a
node may contain other pointers which refer you to a different node,
perhaps in another Info file.  Such pointers are called "cross
references", or "xrefs" for short.

Parts of an Xref
================

   Cross references have two major parts: the first part is called the
"label"; it is the name that you can use to refer to the cross
reference, and the second is the "target"; it is the full name of the
node that the cross reference points to.

   The target is separated from the label by a colon `:'; first the
label appears, and then the target.  For example, in the sample menu
cross reference below, the single colon separates the label from the
target.

     * Foo Label: Foo Target.        More information about Foo.

   Note the `.' which ends the name of the target.  The `.' is not part
of the target; it serves only to let Info know where the target name
ends.

   A shorthand way of specifying references allows two adjacent colons
to stand for a target name which is the same as the label name:

     * Foo Commands::                Commands pertaining to Foo.

   In the above example, the name of the target is the same as the name
of the label, in this case `Foo Commands'.

   You will normally see two types of cross reference while viewing
nodes: "menu" references, and "note" references.  Menu references
appear within a node's menu; they begin with a `*' at the beginning of
a line, and continue with a label, a target, and a comment which
describes what the contents of the node pointed to contains.

   Note references appear within the body of the node text; they begin
with `*Note', and continue with a label and a target.

   Like `Next', `Prev', and `Up' pointers, cross references can point
to any valid node.  They are used to refer you to a place where more
detailed information can be found on a particular subject.  Here is a
cross reference which points to a node within the Texinfo
documentation:  Writing an Xref (texinfo), for more
information on creating your own texinfo cross references.

Selecting Xrefs
===============

   The following table lists the Info commands which operate on menu
items.

<1> (`menu-digit')
<2> ... <9>
<M-1>, vi-like operation
<M-2> ... <M-9>, vi-like operation
     Within an Info window, pressing a single digit, (such as `1'),
     selects that menu item, and places its node in the current window.
     For convenience, there is one exception; pressing `0' selects the
     _last_ item in the node's menu.  When `--vi-keys' is in effect,
     digits set the numeric argument, so these commands are remapped to
     their `M-' varieties.  For example, to select the last menu item,
     press <M-0>.

<0> (`last-menu-item')
<M-0>, vi-like operation
     Select the last item in the current node's menu.

<m> (`menu-item')
     Reads the name of a menu item in the echo area and selects its
     node.  Completion is available while reading the menu label.
     See completion.

`M-x find-menu'
     Move the cursor to the start of this node's menu.

   This table lists the Info commands which operate on cross references.

<f> (`xref-item')
<r>

<M-f>, vi-like operation
`C-x <r>', vi-like operation
     Reads the name of a note cross reference in the echo area and
     selects its node.  Completion is available while reading the cross
     reference label.  See completion.

   Finally, the next few commands operate on menu or note references
alike:

<TAB> (`move-to-next-xref')
     Move the cursor to the start of the next nearest menu item or note
     reference in this node.  You can then use <RET>
     (`select-reference-this-line') to select the menu or note
     reference.

<M-TAB> (`move-to-prev-xref')
<Shift-<TAB>> (on DOS/Windows only)
     Move the cursor the start of the nearest previous menu item or note
     reference in this node.

     On DOS/Windows only, the `Shift-<TAB>' key is an alias for
     `M-<TAB>'.  This key is sometimes called `BackTab'.

<RET> (`select-reference-this-line')
<M-g>, vi-like operation
     Select the menu item or note reference appearing on this line.

Manipulating Multiple Windows
*****************************

   A "window" is a place to show the text of a node.  Windows have a
view area where the text of the node is displayed, and an associated
"mode line", which briefly describes the node being viewed.

   GNU Info supports multiple windows appearing in a single screen; each
window is separated from the next by its modeline.  At any time, there
is only one "active" window, that is, the window in which the cursor
appears.  There are commands available for creating windows, changing
the size of windows, selecting which window is active, and for deleting
windows.

The Mode Line
=============

   A "mode line" is a line of inverse video which appears at the bottom
of an Info window.  It describes the contents of the window just above
it; this information includes the name of the file and node appearing in
that window, the number of screen lines it takes to display the node,
and the percentage of text that is above the top of the window.  It can
also tell you if the indirect tags table for this Info file needs to be
updated, and whether or not the Info file was compressed when stored on
disk.

   Here is a sample mode line for a window containing an uncompressed
file named `dir', showing the node `Top'.

     -----Info: (dir)Top, 40 lines --Top-------------------------------------
                 ^^   ^   ^^^        ^^
               (file)Node #lines    where

   When a node comes from a file which is compressed on disk, this is
indicated in the mode line with two small `z''s.  In addition, if the
Info file containing the node has been split into subfiles, the name of
the subfile containing the node appears in the modeline as well:

     --zz-Info: (emacs)Top, 291 lines --Top-- Subfile: emacs-1.Z-------------

   Truncation of long lines (as opposed to wrapping them to the next
display line, see toggle-wrap) is indicated by a
`$' at the left edge of the mode line:

     --$--Info: (texinfo)Top, 480 lines --Top-- Subfile: texinfo-1-----------

   When Info makes a node internally, such that there is no
corresponding info file on disk, the name of the node is surrounded by
asterisks (`*').  The name itself tells you what the contents of the
window are; the sample mode line below shows an internally constructed
node showing possible completions:

     -----Info: *Completions*, 7 lines --All---------------------------------

Window Commands
===============

   It can be convenient to view more than one node at a time.  To allow
this, Info can display more than one "window".  Each window has its own
mode line (see The Mode Line) and history of nodes viewed in that
window (see `history-node').

`C-x <o>' (`next-window')
     Select the next window on the screen.  Note that the echo area can
     only be selected if it is already in use, and you have left it
     temporarily.  Normally, `C-x o' simply moves the cursor into the
     next window on the screen, or if you are already within the last
     window, into the first window on the screen.  Given a numeric
     argument, `C-x o' moves over that many windows.  A negative
     argument causes `C-x o' to select the previous window on the
     screen.

`M-x prev-window'
     Select the previous window on the screen.  This is identical to
     `C-x o' with a negative argument.

`C-x <2>' (`split-window')
     Split the current window into two windows, both showing the same
     node.  Each window is one half the size of the original window,
     and the cursor remains in the original window.  The variable
     `automatic-tiling' can cause all of the windows on the screen to
     be resized for you automatically, please automatic-tiling
     for more information.

`C-x <0>' (`delete-window')
     Delete the current window from the screen.  If you have made too
     many windows and your screen appears cluttered, this is the way to
     get rid of some of them.

`C-x <1>' (`keep-one-window')
     Delete all of the windows excepting the current one.

`ESC <C-v>' (`scroll-other-window')
     Scroll the other window, in the same fashion that `C-v' might
     scroll the current window.  Given a negative argument, scroll the
     "other" window backward.

`C-x <^>' (`grow-window')
     Grow (or shrink) the current window.  Given a numeric argument,
     grow the current window that many lines; with a negative numeric
     argument, shrink the window instead.

`C-x <t>' (`tile-windows')
     Divide the available screen space among all of the visible windows.
     Each window is given an equal portion of the screen in which to
     display its contents.  The variable `automatic-tiling' can cause
     `tile-windows' to be called when a window is created or deleted.
     See `automatic-tiling'.

The Echo Area
=============

   The "echo area" is a one line window which appears at the bottom of
the screen.  It is used to display informative or error messages, and to
read lines of input from you when that is necessary.  Almost all of the
commands available in the echo area are identical to their Emacs
counterparts, so please refer to that documentation for greater depth of
discussion on the concepts of editing a line of text.  The following
table briefly lists the commands that are available while input is being
read in the echo area:

<C-f> (`echo-area-forward')
<RIGHT> (an arrow key)
<M-h>, vi-like operation
     Move forward a character.

<C-b> (`echo-area-backward')
<LEFT> (an arrow key)
<M-l>, vi-like operation
     Move backward a character.

<C-a> (`echo-area-beg-of-line')
<M-0>, vi-like operation
     Move to the start of the input line.

<C-e> (`echo-area-end-of-line')
<M-$>, vi-like operation
     Move to the end of the input line.

<M-f> (`echo-area-forward-word')
<C-<RIGHT>> (DOS/Windows only)
<M-w>, vi-like operation
     Move forward a word.

     On DOS/Windows, `C-<RIGHT>' moves forward by words.

<M-b> (`echo-area-backward-word')
<C-<LEFT>> (DOS/Windows only)
     Move backward a word.

     On DOS/Windows, `C-<LEFT>' moves backward by words.

<C-d> (`echo-area-delete')
<M-x>, vi-like operation
     Delete the character under the cursor.

<DEL> (`echo-area-rubout')
     Delete the character behind the cursor.

     On some keyboards, this key is designated <BS>, for `BackSpace'.
     Those keyboards will usually bind <DEL> in the echo area to
     `echo-area-delete'.

<C-g> (`echo-area-abort')
<C-u>, vi-like operation
     Cancel or quit the current operation.  If completion is being
     read, this command discards the text of the input line which does
     not match any completion.  If the input line is empty, it aborts
     the calling function.

<RET> (`echo-area-newline')
     Accept (or forces completion of) the current input line.

<C-q> (`echo-area-quoted-insert')
<C-v>, vi-like operation
     Insert the next character verbatim.  This is how you can insert
     control characters into a search string, for example, or the `?'
     character when Info prompts with completion.

PRINTING CHARACTER (`echo-area-insert')
     Insert the character.  Characters that have their 8th bit set, and
     not bound to `M-' commands, are also inserted verbatim; this is
     useful for terminals which support Latin scripts.

<M-TAB> (`echo-area-tab-insert')
<Shift-<TAB>> (on DOS/Windows only)
     Insert a TAB character.

     On DOS/Windows only, the `Shift-<TAB>' key is an alias for
     `M-<TAB>'.  This key is sometimes called `BackTab'.

<C-t> (`echo-area-transpose-chars')
     Transpose the characters at the cursor.

   The next group of commands deal with "killing", and "yanking"
text(1).   For an in depth discussion of killing and yanking, see
Killing and Deleting (emacs).

<M-d> (`echo-area-kill-word')
<M-X>, vi-like operation
     Kill the word following the cursor.

<M-DEL> (`echo-area-backward-kill-word')
<M-<BS>>
     Kill the word preceding the cursor.

     On some keyboards, the `Backspace' key is used instead of `DEL',
     so `M-<Backspace>' has the same effect as `M-<DEL>'.

<C-k> (`echo-area-kill-line')
     Kill the text from the cursor to the end of the line.

`C-x <DEL>' (`echo-area-backward-kill-line')
     Kill the text from the cursor to the beginning of the line.

<C-y> (`echo-area-yank')
     Yank back the contents of the last kill.

<M-y> (`echo-area-yank-pop')
     Yank back a previous kill, removing the last yanked text first.

   Sometimes when reading input in the echo area, the command that
needed input will only accept one of a list of several choices.  The
choices represent the "possible completions", and you must respond with
one of them.  Since there are a limited number of responses you can
make, Info allows you to abbreviate what you type, only typing as much
of the response as is necessary to uniquely identify it.  In addition,
you can request Info to fill in as much of the response as is possible;
this is called "completion".

   The following commands are available when completing in the echo
area:

<TAB> (`echo-area-complete')
<SPC>
     Insert as much of a completion as is possible.

<?> (`echo-area-possible-completions')
     Display a window containing a list of the possible completions of
     what you have typed so far.  For example, if the available choices
     are:

          bar
          foliate
          food
          forget

     and you have typed an `f', followed by `?', Info will pop up a
     window showing a node called `*Completions*' which lists the
     possible completions like this:

          3 completions:
          foliate         food
          forget

     i.e., all of the choices which begin with `f'.  Pressing <SPC> or
     <TAB> would result in `fo' appearing in the echo area, since all
     of the choices which begin with `f' continue with `o'.  Now,
     typing `l' followed by `TAB' results in `foliate' appearing in the
     echo area, since that is the only choice which begins with `fol'.

<ESC C-v> (`echo-area-scroll-completions-window')
     Scroll the completions window, if that is visible, or the "other"
     window if not.

   ---------- Footnotes ----------

   (1) Some people are used to calling these operations "cut" and
"paste", respectively.

Printing Out Nodes
******************

   In general, we recommend that you use TeX to format the document and
print sections of it, by running `tex' on the Texinfo source file.
However, you may wish to print out the contents of a node as a quick
reference document for later use, or if you don't have TeX installed.
Info provides you with a command for doing this.

`M-x print-node'
     Pipe the contents of the current node through the command in the
     environment variable `INFO_PRINT_COMMAND'.  If the variable does
     not exist, the node is simply piped to `lpr' (on DOS/Windows, the
     default is to print the node to the local printer device, `PRN').

     The value of `INFO_PRINT_COMMAND' may begin with the `>'
     character, as in `>/dev/printer', in which case Info treats the
     rest as the name of a file or a device.  Instead of piping to a
     command, Info opens the file, writes the node contents, and closes
     the file, under the assumption that text written to that file will
     be printed by the underlying OS.

Miscellaneous Commands
**********************

   GNU Info contains several commands which self-document GNU Info:

`M-x describe-command'
     Read the name of an Info command in the echo area and then display
     a brief description of what that command does.

`M-x describe-key'
     Read a key sequence in the echo area, and then display the name and
     documentation of the Info command that the key sequence invokes.

`M-x describe-variable'
     Read the name of a variable in the echo area and then display a
     brief description of what the variable affects.

`M-x where-is'
     Read the name of an Info command in the echo area, and then display
     a key sequence which can be typed in order to invoke that command.

<C-h> (`get-help-window')
<?>
<F1> (on DOS/Windows only)
h, vi-like operation
     Create (or Move into) the window displaying `*Help*', and place a
     node containing a quick reference card into it.  This window
     displays the most concise information about GNU Info available.

<h> (`get-info-help-node')
<M-h>, vi-like operation
     Try hard to visit the node `(info)Help'.  The Info file
     `info.texi' distributed with GNU Info contains this node.  Of
     course, the file must first be processed with `makeinfo', and then
     placed into the location of your Info directory.

   Here are the commands for creating a numeric argument:

<C-u> (`universal-argument')
     Start (or multiply by 4) the current numeric argument.  `C-u' is a
     good way to give a small numeric argument to cursor movement or
     scrolling commands; `C-u C-v' scrolls the screen 4 lines, while
     `C-u C-u C-n' moves the cursor down 16 lines.  `C-u' followed by
     digit keys sets the numeric argument to the number thus typed:
     `C-u 1 2 0' sets the argument to 120.

<M-1> (`add-digit-to-numeric-arg')
<1>, vi-like operation
<M-2> ... <M-9>
<2> ... <9>, vi-like operation
<M-0>
<0>, vi-like operation
     Add the digit value of the invoking key to the current numeric
     argument.  Once Info is reading a numeric argument, you may just
     type the digits of the argument, without the Meta prefix.  For
     example, you might give `C-l' a numeric argument of 32 by typing:

          C-u 3 2 C-l

     or

          M-3 2 C-l

<M-> (`add-digit-to-numeric-arg'
<->
     To make a negative argument, type `-'.  Typing `-' alone makes a
     negative argument with a value of -1.  If you continue to type
     digit or Meta-digit keys after `-', the result is a negative
     number produced by those digits.

     `-' doesn't work when you type in the echo area, because you need
     to be able to insert the `-' character itself; use `M--' instead,
     if you need to specify negative arguments in the echo area.

   `C-g' is used to abort the reading of a multi-character key
sequence, to cancel lengthy operations (such as multi-file searches) and
to cancel reading input in the echo area.

<C-g> (`abort-key')
<C-u>, vi-like operation
     Cancel current operation.

   The `q' command of Info simply quits running Info.  Under
`--vi-keys' (see --vi-keys), you can also exit with `:q' or `ZZ'.

<q> (`quit')
`C-x C-c'
`:q', vi-like operation
`ZZ', vi-like operation
     Exit GNU Info.

   If the operating system tells GNU Info that the screen is 60 lines
tall, and it is actually only 40 lines tall, here is a way to tell Info
that the operating system is correct.

`M-x set-screen-height'
     Read a height value in the echo area and set the height of the
     displayed screen to that value.

   On MS-DOS/MS-Windows, this command actually tries to change the
dimensions of the visible screen to the value you type in the echo area.

   Finally, Info provides a convenient way to display footnotes which
might be associated with the current node that you are viewing:

<ESC C-f> (`show-footnotes')
     Show the footnotes (if any) associated with the current node in
     another window.  You can have Info automatically display the
     footnotes associated with a node when the node is selected by
     setting the variable `automatic-footnotes'.  See
     `automatic-footnotes'.

Manipulating Variables
**********************

   GNU Info contains several "variables" whose values are looked at by
various Info commands.  You can change the values of these variables,
and thus change the behavior of Info to more closely match your
environment and Info file reading manner.

`M-x set-variable'
     Read the name of a variable, and the value for it, in the echo
     area and then set the variable to that value.  Completion is
     available when reading the variable name (see completion);
     often, completion is available when reading the value
     to give to the variable, but that depends on the variable itself.
     If a variable does _not_ supply multiple choices to complete over,
     it expects a numeric value.

`M-x describe-variable'
     Read the name of a variable in the echo area and then display a
     brief description of what the variable affects.

   Here is a list of the variables that you can set in Info.

`automatic-footnotes'
     When set to `On', footnotes appear and disappear automatically.
     This variable is `On' by default.  When a node is selected, a
     window containing the footnotes which appear in that node is
     created, and the footnotes are displayed within the new window.
     The window that Info creates to contain the footnotes is called
     `*Footnotes*'.  If a node is selected which contains no footnotes,
     and a `*Footnotes*' window is on the screen, the `*Footnotes*'
     window is deleted.  Footnote windows created in this fashion are
     not automatically tiled so that they can use as little of the
     display as is possible.

`automatic-tiling'
     When set to `On', creating or deleting a window resizes other
     windows.  This variable is `Off' by default.  Normally, typing
     `C-x 2' divides the current window into two equal parts.  When
     `automatic-tiling' is set to `On', all of the windows are resized
     automatically, keeping an equal number of lines visible in each
     window.  There are exceptions to the automatic tiling;
     specifically, the windows `*Completions*' and `*Footnotes*' are
     _not_ resized through automatic tiling; they remain their original
     size.

`visible-bell'
     When set to `On', GNU Info attempts to flash the screen instead of
     ringing the bell.  This variable is `Off' by default.  Of course,
     Info can only flash the screen if the terminal allows it; in the
     case that the terminal does not allow it, the setting of this
     variable has no effect.  However, you can make Info perform
     quietly by setting the `errors-ring-bell' variable to `Off'.

`errors-ring-bell'
     When set to `On', errors cause the bell to ring.  The default
     setting of this variable is `On'.

`gc-compressed-files'
     When set to `On', Info garbage collects files which had to be
     uncompressed.  The default value of this variable is `Off'.
     Whenever a node is visited in Info, the Info file containing that
     node is read into core, and Info reads information about the tags
     and nodes contained in that file.  Once the tags information is
     read by Info, it is never forgotten.  However, the actual text of
     the nodes does not need to remain in core unless a particular Info
     window needs it.  For non-compressed files, the text of the nodes
     does not remain in core when it is no longer in use.  But
     de-compressing a file can be a time consuming operation, and so
     Info tries hard not to do it twice.  `gc-compressed-files' tells
     Info it is okay to garbage collect the text of the nodes of a file
     which was compressed on disk.

`show-index-match'
     When set to `On', the portion of the matched search string is
     highlighted in the message which explains where the matched search
     string was found.  The default value of this variable is `On'.
     When Info displays the location where an index match was found,
     (see `next-index-match'), the portion of the
     string that you had typed is highlighted by displaying it in the
     inverse case from its surrounding characters.

`scroll-behavior'
     Control what happens when forward scrolling is requested at the
     end of a node, or when backward scrolling is requested at the
     beginning of a node.  The default value for this variable is
     `Continuous'.  There are three possible values for this variable:

    `Continuous'
          Try to get the first item in this node's menu, or failing
          that, the `Next' node, or failing that, the `Next' of the
          `Up'.  This behavior is identical to using the `]'
          (`global-next-node') and `[' (`global-prev-node') commands.

    `Next Only'
          Only try to get the `Next' node.

    `Page Only'
          Simply give up, changing nothing.  If `scroll-behavior' is
          `Page Only', no scrolling command can change the node that is
          being viewed.

`scroll-step'
     The number of lines to scroll when the cursor moves out of the
     window.  Scrolling happens automatically if the cursor has moved
     out of the visible portion of the node text when it is time to
     display.  Usually the scrolling is done so as to put the cursor on
     the center line of the current window.  However, if the variable
     `scroll-step' has a nonzero value, Info attempts to scroll the
     node text by that many lines; if that is enough to bring the
     cursor back into the window, that is what is done.  The default
     value of this variable is 0, thus placing the cursor (and the text
     it is attached to) in the center of the window.  Setting this
     variable to 1 causes a kind of "smooth scrolling" which some
     people prefer.

`ISO-Latin'
     When set to `On', Info accepts and displays ISO Latin characters.
     By default, Info assumes an ASCII character set.  `ISO-Latin' tells
     Info that it is running in an environment where the European
     standard character set is in use, and allows you to input such
     characters to Info, as well as display them.